-- count.applescript
-- NanoCount

--  Created by Paul Gorman on Sat Oct 30 2004.
--  Last modified by Paul Gorman on 11 December 2008.
--  Copyright (c) 2004, 2008 Paul Gorman. All rights reserved.

-- what_to_count: Count words or characters?
property what_to_count : "count_words"
-- wcount: The total number of words currently in the front TextEdit window.
property wcount : 0
-- ccount: The total number of characters currently in the front TextEdit window.
property ccount : 0
-- updateInterval: How many seconds the on idle repeat loop sleeps between runs. Setting this too low will burn some serious CPU cycles.
property updateInterval : 2
-- goal: The number of words the user enters in goalField text field.
property goal : 1667


property debug : 0

on idle theObject
	repeat
		tell application "Finder"
			if "TextEdit" is not in name of every process then
				return updateInterval
			end if
		end tell
		tell application "TextEdit"
			if front document exists then
				set docText to text of front document as string
				set tempFile to open for access ("/tmp/nanocount.tmp" as POSIX file) with write permission
				write docText to tempFile as string
				close access tempFile
				-- This next do shell script just runs the text through the unix wc command to get the number of words, then runs that result through a Perl regular express to get just the digits from the result. When it finishes, it removes the temp file. Hurray for little tools. If you change the number or path of the temp file for any reason, make sure there aren't any digits in the name or path.
				if what_to_count is equal to "count_words" then
					set wcount to do shell script "wc -w /tmp/nanocount.tmp | perl -nle '@foo = split(/\\s+/, $_);foreach (@foo) {print if /\\d+/;}'; rm /tmp/nanocount.tmp" as string
				else
					set wcount to do shell script "wc -c /tmp/nanocount.tmp | perl -nle '@foo = split(/\\s+/, $_);foreach (@foo) {print if /\\d+/;}'; rm /tmp/nanocount.tmp" as string
				end if
			end if
		end tell
		tell window "mainWindow"
			set contents of text field "wordcount" to wcount as string
		end tell
		tell progress indicator "goalProgress" of window "mainWindow"
			set maximum value to goal
			set content to wcount
		end tell
		-- Like sleep, as far as I can tell:
		return updateInterval
	end repeat
end idle

on should quit after last window closed theObject
	return 1
end should quit after last window closed

on launched theObject
	set visible of window "mainWindow" to true
end launched

on clicked theObject
	if name of theObject is equal to "2seconds" then
		set updateInterval to 2
	else if name of theObject is equal to "10seconds" then
		set updateInterval to 10
	else if name of theObject is equal to "30seconds" then
		set updateInterval to 30
	else if name of theObject is equal to "5minutes" then
		set updateInterval to 300
	else if name of theObject is equal to "setGoal" then
       set goal to contents of text field "goalField" of drawer "myDrawer" of window "mainWindow"
		tell progress indicator "goalProgress" of window "mainWindow"
           set maximum value to goal
		end tell
	else if name of theObject is equal to "count_words"
		set what_to_count to "count_words"
	else if name of theObject is equal to "count_characters"
		set what_to_count to "count_characters"
	end if
end clicked

on awake from nib theObject
	(*Add your script here.*)
end awake from nib	

on action theObject
	(*Add your script here.*)
end action

